{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Empresas'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/opportunity_list_active.twig" %}
    {% include "template/partial/modal/create_opportunity_in_system.twig" %}    
    {% include "template/partial/modal/search_product.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}
    <script>
        $(document).ready(function () {

            $(".sf-mop").click(function () {
                if ($("#new_client").val() == "") {
                    notify('Debe seleccionar un cliente para la migración!', 'warning');
                    return false;
                }

                if ($("#brand_id").val() == "") {
                    notify('Debe seleccionar una marca!', 'warning');
                    return false;
                }
                if ($("#opportunity_reason").val() == "") {
                    notify('Debe seleccionar un origen!', 'warning');
                    return false;
                }
                if ($("#opportunity_stage").val() == "") {
                    notify('Debe seleccionar una etapa!', 'warning');
                    return false;
                }
                if ($("#opportunity_type").val() == "") {
                    notify('Debe seleccionar un tipo!', 'warning');
                    return false;
                }

                if ($("#user_id").val() == "") {
                    notify('Debe asignar un usuario a la nueva oportunidad!', 'warning');
                    return false;
                }

                if ($("#new_product_id").val() == "") {
                    notify('Debe seleccionar un producto!', 'warning');
                    return false;
                }

                var json = objectifyForm($('#form-mopn').serializeArray());

                /////////

                $.ajax({
                    type: "PUT",
                    url: "migrarOportunidad",
                    data: json,
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);
                        notify('Oportunidad creada correctamente!', 'success');
                        
                        setTimeout(function () {
                            window.location.href = '{{path_for('edit-opportunity', {id: ''})}}' + data;
                        }, 300);

                    },
                    error: function (data) {
                        console.log(data);

                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });

            });

            /******************************************************************/

            var gridClient = $("#data-table-selection").bootgrid({
                css: {
                    icon: 'zmdi icon',
                    iconColumns: 'zmdi-view-module',
                    iconDown: 'zmdi-expand-more',
                    iconRefresh: 'zmdi-refresh',
                    iconUp: 'zmdi-expand-less'
                },
                templates: {
                    header: "",
                },
                selection: true,
                multiSelect: true,
                rowSelect: true,
                keepSelection: true,
                formatters: {
                    "commands": function (column, row) {
                        return "<button \n\
                                                            type=\"button\" \n\
                                                            class=\"btn btn-icon command-cliente waves-effect waves-circle event-modal\" \n\
                                                            title=\"" + ((row.opm_id != "") ? 'Migrada Op#' + row.opm_id : 'Crear oportunidad en el sistema') + "\" \n\
                                                            data-op-id=\"" + row.op_id + "\"\n\
                                                            data-cliente=\"" + row.cliente + "\"\n\
                                                            data-origen=\"" + row.origen + "\"\n\
                                                            data-contacto=\"" + row.contacto + "\"\n\
                                                            data-producto=\"" + row.producto + "\"\n\
                                                            data-cantidad=\"" + row.cantidad + "\"\n\
                                                            data-presupuesto=\"" + row.presupuesto + "\"\n\
                                                            data-fecha-alta=\"" + row.fecha_alta + "\"\n\
                                                            data-etapa=\"" + row.etapa + "\"\n\
                                                            data-atiende=\"" + row.atiende + "\"\n\
                                                            data-ultimo-realizado=\"" + row.ultimo_realizado + "\"\n\
                                                            data-realizar=\"" + row.a_realizar + "\"\n\
                                                            " + ((row.opm_id != "") ? 'disabled="disabled"' : '') + ">\n\
                                                                    <span class=\"zmdi zmdi-plus-circle-o\"></span>\n\
                                                    </button>";
                    },
                    "cliente": function (column, row) {
                        var col = "<b>" + row.cliente + "</b>";

                        if (row.opm_id != "") {
                            col = col + "<br><a href='editar/" + row.opm_id + "' class='c-green'>Migrada Op#" + row.opm_id + "</a>";
                        }

                        return col;
                    }
                }
            }).on("loaded.rs.jquery.bootgrid", function () {

                gridClient.find(".event-modal").on("click", function (e) {
                    var clientOpId = $(this).data("op-id");
                    var clientName = $(this).data("cliente");
                    var clientorigen = $(this).data("origen");
                    var clientetapa = $(this).data("etapa");
                    var clientatiende = $(this).data("atiende");
                    var clientproducto = $(this).data("producto");
                    var clientCantidad = $(this).data("cantidad");
                    var clientPresupuesto = $(this).data("presupuesto");
                    var clientContacto = $(this).data("contacto");
                    var clientFechaAlta = $(this).data("fecha-alta");
                    var clientUltimoRealizado = $(this).data("ultimo-realizado");

                    $('#clienteActual').html(clientName);
                    $('#origenActual').html(clientorigen);
                    $('#etapaActual').html(clientetapa);
                    $('#atiendeActual').html(clientatiende);
                    $('#productoActual').html(clientproducto);

                    $('#new_opportunity_id').val(clientOpId);
                    $('#new_cantidad').val(clientCantidad);
                    $('#new_presupuesto').val(clientPresupuesto);
                    $('#new_contacto').val(clientContacto);
                    $('#new_fecha').val(clientFechaAlta);
                    $('#new_follow').val(clientUltimoRealizado);

                    suggestionClient(clientName);

                    $('#modalWider').modal('show');
                });
            });

            var suggestionClient = function (name) {
                $('#new_cliente_suggestion').val('');
                $.ajax({
                    type: "GET",
                    url: "../cliente/name/" + name,
                    dataType: "JSON",
                    success: function (data) {
                        if (data.length > 0) {
                            $('#new_cliente_suggestion').val(data[0].client_businessname);
                            $('#nuevo-cliente').parent().hide();
                        } else {
                            $('#nuevo-cliente').parent().show();
                        }
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            };

            $(".sf-bpop").click(function () {
                var json = objectifyForm($('#form-bpop').serializeArray());

                if ($("#keyword").val() == "" && $("#sku").val() == "" && $("#hardware").val() == "") {
                    notify('Debe completar al menos un campo de búsqueda!', 'warning');
                    return;
                }

                var brand = $("#brand_id_search").val();
                var keyword = $("#keyword").val();
                var sku = $("#sku").val();
                var hardware = $("#hardware").val();

                if (brand == "") {
                    brand = "0";
                }
                if (keyword == "") {
                    keyword = "-";
                }
                if (sku == "") {
                    sku = "-";
                }
                if (hardware == "") {
                    hardware = "-";
                }

                /////////

                $.ajax({
                    type: "GET",
                    url: "jsonProductos/" + brand + "/" + sku + "/" + keyword + "/" + hardware,
                    /*data: json,*/
                    dataType: "JSON",
                    success: function (data) {
                        $('#elementsTable').html("");

                        for (var i in data) {
                            if (data[i].family && data[i].family != "") {
                                $('#elementsTable').append("<tr onclick=\"productData('" + data[i].product_id + "','" + data[i].description1 + "','" + data[i].item + "','" + data[i].type + "','" + data[i].price + "','" + data[i].sku + "');\">" +
                                        "<td>" + data[i].family + "</td>" +
                                        "<td>" + data[i].item + "</td>" +
                                        "<td>" + data[i].type + "</td>" +
                                        "<td>" + data[i].sku + "</td>" +
                                        "<td>" + data[i].description1 + "</td>" +
                                        "<td>" + data[i].price + "</td>" +
                                        "<td>" + data[i].category + "</td>" +
                                        "</tr>");
                            }
                        }

                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });

            var dataSource2 = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                prefetch: {
                    url: "{{base_url()}}/oportunidad/jsonClientes",
                    cache: false,
                    ttl: 1
                }
            });

            $('.typeclients').typeahead({
                hint: true,
                cache: false,
                ttl: 60,
                highlight: true,
                minLength: 1
            },
                    {
                        displayKey: 'name',
                        name: 'clients',
                        valueKey: 'id',
                        source: dataSource2.ttAdapter()
                    }).bind("typeahead:selected", function (obj, datum, name) {
                //if (this.id == "new_client") {
                $("#client_id_value").val(datum.id);

                /*$.ajax({
                 type: "GET",
                 url: "{{base_url()}}/oportunidad/jsonContactos/" + datum.id,
                 dataType: "JSON",
                 success: function (data) {
                 console.log(data);
                 $('#contact_id_value').html("");
                 
                 for (var i in data) {
                 $('#contact_id_value').append("<option value='" + data[i].id + "'>" + data[i].name + "</option>");
                 }
                 
                 $('#contact_id_value').trigger("chosen:updated");
                 }
                 });
                 
                 $.ajax({
                 type: "GET",
                 url: "{{base_url()}}/oportunidad/jsonCliente/"+datum.id+"/type",
                 dataType: "JSON",
                 success: function (data) {
                 console.log(data);
                 if(data.client_type === "Integrador") {
                 $('#tesn').removeAttr('disabled')
                 } else {
                 $('#tesn').attr('disabled', 'disabled');
                 }
                 }
                 });*/

                //}

                /*if (this.id == "opportunity_integrator_user_id") {
                 $("#opportunity_integrator_user_id_value").val(datum.id);
                 }
                 
                 if (this.id == "opportunity_subclient_id") {
                 $("#opportunity_subclient_id_value").val(datum.id);
                 }*/
            });


            $('#nuevo-cliente').click(function (e) {
                e.preventDefault();
                $.ajax({
                    type: "POST",
                    url: "../cliente/crear",
                    success: function (data) {
                        console.log(data);

                        //notify('Informacion registrada correctamente!', 'success');

                        setTimeout(function () {
                            window.location.href = "../cliente/editar/" + data;
                        }, 0);
                    },
                    error: function (data) {
                        console.log(data);

                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });
        });
        function productData(product_id, description1, item, type, price, sku) {
            $('#new_product_id').val(product_id);
            $('#new_producto').val(item);

            $("#modalProducts").modal('hide');
        }
        ;

    </script>
{% endblock %}